// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.


using System;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;
using System.Text;
using Silk.NET.Core;
using Silk.NET.Core.Native;
using Silk.NET.Core.Attributes;
using Silk.NET.Core.Contexts;
using Silk.NET.Core.Loader;

#pragma warning disable 1591

namespace Silk.NET.Direct3D12
{
    [NativeName("Name", "__AnonymousRecord_d3d12_L4096_C9")]
    public unsafe partial struct IndirectArgumentDescUnionVertexBuffer
    {
        public IndirectArgumentDescUnionVertexBuffer
        (
            uint? slot = null
        ) : this()
        {
            if (slot is not null)
            {
                Slot = slot.Value;
            }
        }


        [NativeName("Type", "UINT")]
        [NativeName("Type.Name", "UINT")]
        [NativeName("Name", "Slot")]
        public uint Slot;
    }
}
