// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.


using System;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;
using System.Text;
using Silk.NET.Core;
using Silk.NET.Core.Native;
using Silk.NET.Core.Attributes;
using Silk.NET.Core.Contexts;
using Silk.NET.Core.Loader;

#pragma warning disable 1591

namespace Silk.NET.OpenXR
{
    [NativeName("Name", "XrScenePlanesMSFT")]
    public unsafe partial struct ScenePlanesMSFT
    {
        public ScenePlanesMSFT
        (
            StructureType? type = StructureType.TypeScenePlanesMsft,
            void* next = null,
            uint? scenePlaneCount = null,
            ScenePlaneMSFT* scenePlanes = null
        ) : this()
        {
            if (type is not null)
            {
                Type = type.Value;
            }

            if (next is not null)
            {
                Next = next;
            }

            if (scenePlaneCount is not null)
            {
                ScenePlaneCount = scenePlaneCount.Value;
            }

            if (scenePlanes is not null)
            {
                ScenePlanes = scenePlanes;
            }
        }

/// <summary></summary>
        [NativeName("Type", "XrStructureType")]
        [NativeName("Type.Name", "XrStructureType")]
        [NativeName("Name", "type")]
        public StructureType Type;
/// <summary></summary>
        [NativeName("Type", "void*")]
        [NativeName("Type.Name", "void")]
        [NativeName("Name", "next")]
        public void* Next;
/// <summary></summary>
        [NativeName("Type", "uint32_t")]
        [NativeName("Type.Name", "uint32_t")]
        [NativeName("Name", "scenePlaneCount")]
        public uint ScenePlaneCount;
/// <summary></summary>
        [NativeName("Type", "XrScenePlaneMSFT*")]
        [NativeName("Type.Name", "XrScenePlaneMSFT")]
        [NativeName("Name", "scenePlanes")]
        public ScenePlaneMSFT* ScenePlanes;
    }
}
