// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.


using System;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;
using System.Text;
using Silk.NET.Core;
using Silk.NET.Core.Native;
using Silk.NET.Core.Attributes;
using Silk.NET.Core.Contexts;
using Silk.NET.Core.Loader;

#pragma warning disable 1591

namespace Silk.NET.Vulkan
{
    [NativeName("Name", "VkAttachmentReference")]
    public unsafe partial struct AttachmentReference
    {
        public AttachmentReference
        (
            uint? attachment = null,
            ImageLayout? layout = null
        ) : this()
        {
            if (attachment is not null)
            {
                Attachment = attachment.Value;
            }

            if (layout is not null)
            {
                Layout = layout.Value;
            }
        }

/// <summary></summary>
        [NativeName("Type", "uint32_t")]
        [NativeName("Type.Name", "uint32_t")]
        [NativeName("Name", "attachment")]
        public uint Attachment;
/// <summary></summary>
        [NativeName("Type", "VkImageLayout")]
        [NativeName("Type.Name", "VkImageLayout")]
        [NativeName("Name", "layout")]
        public ImageLayout Layout;
    }
}
