// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.


using System;
using Silk.NET.Core.Attributes;

#pragma warning disable 1591

namespace Silk.NET.SDL
{
    [NativeName("AnonymousName", "__AnonymousEnum_SDL_scancode_L43_C9")]
    [NativeName("Name", "SDL_Scancode")]
    public enum Scancode : int
    {
        [NativeName("Name", "SDL_SCANCODE_UNKNOWN")]
        ScancodeUnknown = 0x0,
        [NativeName("Name", "SDL_SCANCODE_A")]
        ScancodeA = 0x4,
        [NativeName("Name", "SDL_SCANCODE_B")]
        ScancodeB = 0x5,
        [NativeName("Name", "SDL_SCANCODE_C")]
        ScancodeC = 0x6,
        [NativeName("Name", "SDL_SCANCODE_D")]
        ScancodeD = 0x7,
        [NativeName("Name", "SDL_SCANCODE_E")]
        ScancodeE = 0x8,
        [NativeName("Name", "SDL_SCANCODE_F")]
        ScancodeF = 0x9,
        [NativeName("Name", "SDL_SCANCODE_G")]
        ScancodeG = 0xA,
        [NativeName("Name", "SDL_SCANCODE_H")]
        ScancodeH = 0xB,
        [NativeName("Name", "SDL_SCANCODE_I")]
        ScancodeI = 0xC,
        [NativeName("Name", "SDL_SCANCODE_J")]
        ScancodeJ = 0xD,
        [NativeName("Name", "SDL_SCANCODE_K")]
        ScancodeK = 0xE,
        [NativeName("Name", "SDL_SCANCODE_L")]
        ScancodeL = 0xF,
        [NativeName("Name", "SDL_SCANCODE_M")]
        ScancodeM = 0x10,
        [NativeName("Name", "SDL_SCANCODE_N")]
        ScancodeN = 0x11,
        [NativeName("Name", "SDL_SCANCODE_O")]
        ScancodeO = 0x12,
        [NativeName("Name", "SDL_SCANCODE_P")]
        ScancodeP = 0x13,
        [NativeName("Name", "SDL_SCANCODE_Q")]
        ScancodeQ = 0x14,
        [NativeName("Name", "SDL_SCANCODE_R")]
        ScancodeR = 0x15,
        [NativeName("Name", "SDL_SCANCODE_S")]
        ScancodeS = 0x16,
        [NativeName("Name", "SDL_SCANCODE_T")]
        ScancodeT = 0x17,
        [NativeName("Name", "SDL_SCANCODE_U")]
        ScancodeU = 0x18,
        [NativeName("Name", "SDL_SCANCODE_V")]
        ScancodeV = 0x19,
        [NativeName("Name", "SDL_SCANCODE_W")]
        ScancodeW = 0x1A,
        [NativeName("Name", "SDL_SCANCODE_X")]
        ScancodeX = 0x1B,
        [NativeName("Name", "SDL_SCANCODE_Y")]
        ScancodeY = 0x1C,
        [NativeName("Name", "SDL_SCANCODE_Z")]
        ScancodeZ = 0x1D,
        [NativeName("Name", "SDL_SCANCODE_1")]
        Scancode1 = 0x1E,
        [NativeName("Name", "SDL_SCANCODE_2")]
        Scancode2 = 0x1F,
        [NativeName("Name", "SDL_SCANCODE_3")]
        Scancode3 = 0x20,
        [NativeName("Name", "SDL_SCANCODE_4")]
        Scancode4 = 0x21,
        [NativeName("Name", "SDL_SCANCODE_5")]
        Scancode5 = 0x22,
        [NativeName("Name", "SDL_SCANCODE_6")]
        Scancode6 = 0x23,
        [NativeName("Name", "SDL_SCANCODE_7")]
        Scancode7 = 0x24,
        [NativeName("Name", "SDL_SCANCODE_8")]
        Scancode8 = 0x25,
        [NativeName("Name", "SDL_SCANCODE_9")]
        Scancode9 = 0x26,
        [NativeName("Name", "SDL_SCANCODE_0")]
        Scancode0 = 0x27,
        [NativeName("Name", "SDL_SCANCODE_RETURN")]
        ScancodeReturn = 0x28,
        [NativeName("Name", "SDL_SCANCODE_ESCAPE")]
        ScancodeEscape = 0x29,
        [NativeName("Name", "SDL_SCANCODE_BACKSPACE")]
        ScancodeBackspace = 0x2A,
        [NativeName("Name", "SDL_SCANCODE_TAB")]
        ScancodeTab = 0x2B,
        [NativeName("Name", "SDL_SCANCODE_SPACE")]
        ScancodeSpace = 0x2C,
        [NativeName("Name", "SDL_SCANCODE_MINUS")]
        ScancodeMinus = 0x2D,
        [NativeName("Name", "SDL_SCANCODE_EQUALS")]
        ScancodeEquals = 0x2E,
        [NativeName("Name", "SDL_SCANCODE_LEFTBRACKET")]
        ScancodeLeftbracket = 0x2F,
        [NativeName("Name", "SDL_SCANCODE_RIGHTBRACKET")]
        ScancodeRightbracket = 0x30,
        [NativeName("Name", "SDL_SCANCODE_BACKSLASH")]
        ScancodeBackslash = 0x31,
        [NativeName("Name", "SDL_SCANCODE_NONUSHASH")]
        ScancodeNonushash = 0x32,
        [NativeName("Name", "SDL_SCANCODE_SEMICOLON")]
        ScancodeSemicolon = 0x33,
        [NativeName("Name", "SDL_SCANCODE_APOSTROPHE")]
        ScancodeApostrophe = 0x34,
        [NativeName("Name", "SDL_SCANCODE_GRAVE")]
        ScancodeGrave = 0x35,
        [NativeName("Name", "SDL_SCANCODE_COMMA")]
        ScancodeComma = 0x36,
        [NativeName("Name", "SDL_SCANCODE_PERIOD")]
        ScancodePeriod = 0x37,
        [NativeName("Name", "SDL_SCANCODE_SLASH")]
        ScancodeSlash = 0x38,
        [NativeName("Name", "SDL_SCANCODE_CAPSLOCK")]
        ScancodeCapslock = 0x39,
        [NativeName("Name", "SDL_SCANCODE_F1")]
        ScancodeF1 = 0x3A,
        [NativeName("Name", "SDL_SCANCODE_F2")]
        ScancodeF2 = 0x3B,
        [NativeName("Name", "SDL_SCANCODE_F3")]
        ScancodeF3 = 0x3C,
        [NativeName("Name", "SDL_SCANCODE_F4")]
        ScancodeF4 = 0x3D,
        [NativeName("Name", "SDL_SCANCODE_F5")]
        ScancodeF5 = 0x3E,
        [NativeName("Name", "SDL_SCANCODE_F6")]
        ScancodeF6 = 0x3F,
        [NativeName("Name", "SDL_SCANCODE_F7")]
        ScancodeF7 = 0x40,
        [NativeName("Name", "SDL_SCANCODE_F8")]
        ScancodeF8 = 0x41,
        [NativeName("Name", "SDL_SCANCODE_F9")]
        ScancodeF9 = 0x42,
        [NativeName("Name", "SDL_SCANCODE_F10")]
        ScancodeF10 = 0x43,
        [NativeName("Name", "SDL_SCANCODE_F11")]
        ScancodeF11 = 0x44,
        [NativeName("Name", "SDL_SCANCODE_F12")]
        ScancodeF12 = 0x45,
        [NativeName("Name", "SDL_SCANCODE_PRINTSCREEN")]
        ScancodePrintscreen = 0x46,
        [NativeName("Name", "SDL_SCANCODE_SCROLLLOCK")]
        ScancodeScrolllock = 0x47,
        [NativeName("Name", "SDL_SCANCODE_PAUSE")]
        ScancodePause = 0x48,
        [NativeName("Name", "SDL_SCANCODE_INSERT")]
        ScancodeInsert = 0x49,
        [NativeName("Name", "SDL_SCANCODE_HOME")]
        ScancodeHome = 0x4A,
        [NativeName("Name", "SDL_SCANCODE_PAGEUP")]
        ScancodePageup = 0x4B,
        [NativeName("Name", "SDL_SCANCODE_DELETE")]
        ScancodeDelete = 0x4C,
        [NativeName("Name", "SDL_SCANCODE_END")]
        ScancodeEnd = 0x4D,
        [NativeName("Name", "SDL_SCANCODE_PAGEDOWN")]
        ScancodePagedown = 0x4E,
        [NativeName("Name", "SDL_SCANCODE_RIGHT")]
        ScancodeRight = 0x4F,
        [NativeName("Name", "SDL_SCANCODE_LEFT")]
        ScancodeLeft = 0x50,
        [NativeName("Name", "SDL_SCANCODE_DOWN")]
        ScancodeDown = 0x51,
        [NativeName("Name", "SDL_SCANCODE_UP")]
        ScancodeUp = 0x52,
        [NativeName("Name", "SDL_SCANCODE_NUMLOCKCLEAR")]
        ScancodeNumlockclear = 0x53,
        [NativeName("Name", "SDL_SCANCODE_KP_DIVIDE")]
        ScancodeKPDivide = 0x54,
        [NativeName("Name", "SDL_SCANCODE_KP_MULTIPLY")]
        ScancodeKPMultiply = 0x55,
        [NativeName("Name", "SDL_SCANCODE_KP_MINUS")]
        ScancodeKPMinus = 0x56,
        [NativeName("Name", "SDL_SCANCODE_KP_PLUS")]
        ScancodeKPPlus = 0x57,
        [NativeName("Name", "SDL_SCANCODE_KP_ENTER")]
        ScancodeKPEnter = 0x58,
        [NativeName("Name", "SDL_SCANCODE_KP_1")]
        ScancodeKP1 = 0x59,
        [NativeName("Name", "SDL_SCANCODE_KP_2")]
        ScancodeKP2 = 0x5A,
        [NativeName("Name", "SDL_SCANCODE_KP_3")]
        ScancodeKP3 = 0x5B,
        [NativeName("Name", "SDL_SCANCODE_KP_4")]
        ScancodeKP4 = 0x5C,
        [NativeName("Name", "SDL_SCANCODE_KP_5")]
        ScancodeKP5 = 0x5D,
        [NativeName("Name", "SDL_SCANCODE_KP_6")]
        ScancodeKP6 = 0x5E,
        [NativeName("Name", "SDL_SCANCODE_KP_7")]
        ScancodeKP7 = 0x5F,
        [NativeName("Name", "SDL_SCANCODE_KP_8")]
        ScancodeKP8 = 0x60,
        [NativeName("Name", "SDL_SCANCODE_KP_9")]
        ScancodeKP9 = 0x61,
        [NativeName("Name", "SDL_SCANCODE_KP_0")]
        ScancodeKP0 = 0x62,
        [NativeName("Name", "SDL_SCANCODE_KP_PERIOD")]
        ScancodeKPPeriod = 0x63,
        [NativeName("Name", "SDL_SCANCODE_NONUSBACKSLASH")]
        ScancodeNonusbackslash = 0x64,
        [NativeName("Name", "SDL_SCANCODE_APPLICATION")]
        ScancodeApplication = 0x65,
        [NativeName("Name", "SDL_SCANCODE_POWER")]
        ScancodePower = 0x66,
        [NativeName("Name", "SDL_SCANCODE_KP_EQUALS")]
        ScancodeKPEquals = 0x67,
        [NativeName("Name", "SDL_SCANCODE_F13")]
        ScancodeF13 = 0x68,
        [NativeName("Name", "SDL_SCANCODE_F14")]
        ScancodeF14 = 0x69,
        [NativeName("Name", "SDL_SCANCODE_F15")]
        ScancodeF15 = 0x6A,
        [NativeName("Name", "SDL_SCANCODE_F16")]
        ScancodeF16 = 0x6B,
        [NativeName("Name", "SDL_SCANCODE_F17")]
        ScancodeF17 = 0x6C,
        [NativeName("Name", "SDL_SCANCODE_F18")]
        ScancodeF18 = 0x6D,
        [NativeName("Name", "SDL_SCANCODE_F19")]
        ScancodeF19 = 0x6E,
        [NativeName("Name", "SDL_SCANCODE_F20")]
        ScancodeF20 = 0x6F,
        [NativeName("Name", "SDL_SCANCODE_F21")]
        ScancodeF21 = 0x70,
        [NativeName("Name", "SDL_SCANCODE_F22")]
        ScancodeF22 = 0x71,
        [NativeName("Name", "SDL_SCANCODE_F23")]
        ScancodeF23 = 0x72,
        [NativeName("Name", "SDL_SCANCODE_F24")]
        ScancodeF24 = 0x73,
        [NativeName("Name", "SDL_SCANCODE_EXECUTE")]
        ScancodeExecute = 0x74,
        [NativeName("Name", "SDL_SCANCODE_HELP")]
        ScancodeHelp = 0x75,
        [NativeName("Name", "SDL_SCANCODE_MENU")]
        ScancodeMenu = 0x76,
        [NativeName("Name", "SDL_SCANCODE_SELECT")]
        ScancodeSelect = 0x77,
        [NativeName("Name", "SDL_SCANCODE_STOP")]
        ScancodeStop = 0x78,
        [NativeName("Name", "SDL_SCANCODE_AGAIN")]
        ScancodeAgain = 0x79,
        [NativeName("Name", "SDL_SCANCODE_UNDO")]
        ScancodeUndo = 0x7A,
        [NativeName("Name", "SDL_SCANCODE_CUT")]
        ScancodeCut = 0x7B,
        [NativeName("Name", "SDL_SCANCODE_COPY")]
        ScancodeCopy = 0x7C,
        [NativeName("Name", "SDL_SCANCODE_PASTE")]
        ScancodePaste = 0x7D,
        [NativeName("Name", "SDL_SCANCODE_FIND")]
        ScancodeFind = 0x7E,
        [NativeName("Name", "SDL_SCANCODE_MUTE")]
        ScancodeMute = 0x7F,
        [NativeName("Name", "SDL_SCANCODE_VOLUMEUP")]
        ScancodeVolumeup = 0x80,
        [NativeName("Name", "SDL_SCANCODE_VOLUMEDOWN")]
        ScancodeVolumedown = 0x81,
        [NativeName("Name", "SDL_SCANCODE_KP_COMMA")]
        ScancodeKPComma = 0x85,
        [NativeName("Name", "SDL_SCANCODE_KP_EQUALSAS400")]
        ScancodeKPEqualsas400 = 0x86,
        [NativeName("Name", "SDL_SCANCODE_INTERNATIONAL1")]
        ScancodeInternational1 = 0x87,
        [NativeName("Name", "SDL_SCANCODE_INTERNATIONAL2")]
        ScancodeInternational2 = 0x88,
        [NativeName("Name", "SDL_SCANCODE_INTERNATIONAL3")]
        ScancodeInternational3 = 0x89,
        [NativeName("Name", "SDL_SCANCODE_INTERNATIONAL4")]
        ScancodeInternational4 = 0x8A,
        [NativeName("Name", "SDL_SCANCODE_INTERNATIONAL5")]
        ScancodeInternational5 = 0x8B,
        [NativeName("Name", "SDL_SCANCODE_INTERNATIONAL6")]
        ScancodeInternational6 = 0x8C,
        [NativeName("Name", "SDL_SCANCODE_INTERNATIONAL7")]
        ScancodeInternational7 = 0x8D,
        [NativeName("Name", "SDL_SCANCODE_INTERNATIONAL8")]
        ScancodeInternational8 = 0x8E,
        [NativeName("Name", "SDL_SCANCODE_INTERNATIONAL9")]
        ScancodeInternational9 = 0x8F,
        [NativeName("Name", "SDL_SCANCODE_LANG1")]
        ScancodeLang1 = 0x90,
        [NativeName("Name", "SDL_SCANCODE_LANG2")]
        ScancodeLang2 = 0x91,
        [NativeName("Name", "SDL_SCANCODE_LANG3")]
        ScancodeLang3 = 0x92,
        [NativeName("Name", "SDL_SCANCODE_LANG4")]
        ScancodeLang4 = 0x93,
        [NativeName("Name", "SDL_SCANCODE_LANG5")]
        ScancodeLang5 = 0x94,
        [NativeName("Name", "SDL_SCANCODE_LANG6")]
        ScancodeLang6 = 0x95,
        [NativeName("Name", "SDL_SCANCODE_LANG7")]
        ScancodeLang7 = 0x96,
        [NativeName("Name", "SDL_SCANCODE_LANG8")]
        ScancodeLang8 = 0x97,
        [NativeName("Name", "SDL_SCANCODE_LANG9")]
        ScancodeLang9 = 0x98,
        [NativeName("Name", "SDL_SCANCODE_ALTERASE")]
        ScancodeAlterase = 0x99,
        [NativeName("Name", "SDL_SCANCODE_SYSREQ")]
        ScancodeSysreq = 0x9A,
        [NativeName("Name", "SDL_SCANCODE_CANCEL")]
        ScancodeCancel = 0x9B,
        [NativeName("Name", "SDL_SCANCODE_CLEAR")]
        ScancodeClear = 0x9C,
        [NativeName("Name", "SDL_SCANCODE_PRIOR")]
        ScancodePrior = 0x9D,
        [NativeName("Name", "SDL_SCANCODE_RETURN2")]
        ScancodeReturn2 = 0x9E,
        [NativeName("Name", "SDL_SCANCODE_SEPARATOR")]
        ScancodeSeparator = 0x9F,
        [NativeName("Name", "SDL_SCANCODE_OUT")]
        ScancodeOut = 0xA0,
        [NativeName("Name", "SDL_SCANCODE_OPER")]
        ScancodeOper = 0xA1,
        [NativeName("Name", "SDL_SCANCODE_CLEARAGAIN")]
        ScancodeClearagain = 0xA2,
        [NativeName("Name", "SDL_SCANCODE_CRSEL")]
        ScancodeCrsel = 0xA3,
        [NativeName("Name", "SDL_SCANCODE_EXSEL")]
        ScancodeExsel = 0xA4,
        [NativeName("Name", "SDL_SCANCODE_KP_00")]
        ScancodeKP00 = 0xB0,
        [NativeName("Name", "SDL_SCANCODE_KP_000")]
        ScancodeKP000 = 0xB1,
        [NativeName("Name", "SDL_SCANCODE_THOUSANDSSEPARATOR")]
        ScancodeThousandsseparator = 0xB2,
        [NativeName("Name", "SDL_SCANCODE_DECIMALSEPARATOR")]
        ScancodeDecimalseparator = 0xB3,
        [NativeName("Name", "SDL_SCANCODE_CURRENCYUNIT")]
        ScancodeCurrencyunit = 0xB4,
        [NativeName("Name", "SDL_SCANCODE_CURRENCYSUBUNIT")]
        ScancodeCurrencysubunit = 0xB5,
        [NativeName("Name", "SDL_SCANCODE_KP_LEFTPAREN")]
        ScancodeKPLeftparen = 0xB6,
        [NativeName("Name", "SDL_SCANCODE_KP_RIGHTPAREN")]
        ScancodeKPRightparen = 0xB7,
        [NativeName("Name", "SDL_SCANCODE_KP_LEFTBRACE")]
        ScancodeKPLeftbrace = 0xB8,
        [NativeName("Name", "SDL_SCANCODE_KP_RIGHTBRACE")]
        ScancodeKPRightbrace = 0xB9,
        [NativeName("Name", "SDL_SCANCODE_KP_TAB")]
        ScancodeKPTab = 0xBA,
        [NativeName("Name", "SDL_SCANCODE_KP_BACKSPACE")]
        ScancodeKPBackspace = 0xBB,
        [NativeName("Name", "SDL_SCANCODE_KP_A")]
        ScancodeKPA = 0xBC,
        [NativeName("Name", "SDL_SCANCODE_KP_B")]
        ScancodeKPB = 0xBD,
        [NativeName("Name", "SDL_SCANCODE_KP_C")]
        ScancodeKPC = 0xBE,
        [NativeName("Name", "SDL_SCANCODE_KP_D")]
        ScancodeKPD = 0xBF,
        [NativeName("Name", "SDL_SCANCODE_KP_E")]
        ScancodeKPE = 0xC0,
        [NativeName("Name", "SDL_SCANCODE_KP_F")]
        ScancodeKPF = 0xC1,
        [NativeName("Name", "SDL_SCANCODE_KP_XOR")]
        ScancodeKPXor = 0xC2,
        [NativeName("Name", "SDL_SCANCODE_KP_POWER")]
        ScancodeKPPower = 0xC3,
        [NativeName("Name", "SDL_SCANCODE_KP_PERCENT")]
        ScancodeKPPercent = 0xC4,
        [NativeName("Name", "SDL_SCANCODE_KP_LESS")]
        ScancodeKPLess = 0xC5,
        [NativeName("Name", "SDL_SCANCODE_KP_GREATER")]
        ScancodeKPGreater = 0xC6,
        [NativeName("Name", "SDL_SCANCODE_KP_AMPERSAND")]
        ScancodeKPAmpersand = 0xC7,
        [NativeName("Name", "SDL_SCANCODE_KP_DBLAMPERSAND")]
        ScancodeKPDblampersand = 0xC8,
        [NativeName("Name", "SDL_SCANCODE_KP_VERTICALBAR")]
        ScancodeKPVerticalbar = 0xC9,
        [NativeName("Name", "SDL_SCANCODE_KP_DBLVERTICALBAR")]
        ScancodeKPDblverticalbar = 0xCA,
        [NativeName("Name", "SDL_SCANCODE_KP_COLON")]
        ScancodeKPColon = 0xCB,
        [NativeName("Name", "SDL_SCANCODE_KP_HASH")]
        ScancodeKPHash = 0xCC,
        [NativeName("Name", "SDL_SCANCODE_KP_SPACE")]
        ScancodeKPSpace = 0xCD,
        [NativeName("Name", "SDL_SCANCODE_KP_AT")]
        ScancodeKPAT = 0xCE,
        [NativeName("Name", "SDL_SCANCODE_KP_EXCLAM")]
        ScancodeKPExclam = 0xCF,
        [NativeName("Name", "SDL_SCANCODE_KP_MEMSTORE")]
        ScancodeKPMemstore = 0xD0,
        [NativeName("Name", "SDL_SCANCODE_KP_MEMRECALL")]
        ScancodeKPMemrecall = 0xD1,
        [NativeName("Name", "SDL_SCANCODE_KP_MEMCLEAR")]
        ScancodeKPMemclear = 0xD2,
        [NativeName("Name", "SDL_SCANCODE_KP_MEMADD")]
        ScancodeKPMemadd = 0xD3,
        [NativeName("Name", "SDL_SCANCODE_KP_MEMSUBTRACT")]
        ScancodeKPMemsubtract = 0xD4,
        [NativeName("Name", "SDL_SCANCODE_KP_MEMMULTIPLY")]
        ScancodeKPMemmultiply = 0xD5,
        [NativeName("Name", "SDL_SCANCODE_KP_MEMDIVIDE")]
        ScancodeKPMemdivide = 0xD6,
        [NativeName("Name", "SDL_SCANCODE_KP_PLUSMINUS")]
        ScancodeKPPlusminus = 0xD7,
        [NativeName("Name", "SDL_SCANCODE_KP_CLEAR")]
        ScancodeKPClear = 0xD8,
        [NativeName("Name", "SDL_SCANCODE_KP_CLEARENTRY")]
        ScancodeKPClearentry = 0xD9,
        [NativeName("Name", "SDL_SCANCODE_KP_BINARY")]
        ScancodeKPBinary = 0xDA,
        [NativeName("Name", "SDL_SCANCODE_KP_OCTAL")]
        ScancodeKPOctal = 0xDB,
        [NativeName("Name", "SDL_SCANCODE_KP_DECIMAL")]
        ScancodeKPDecimal = 0xDC,
        [NativeName("Name", "SDL_SCANCODE_KP_HEXADECIMAL")]
        ScancodeKPHexadecimal = 0xDD,
        [NativeName("Name", "SDL_SCANCODE_LCTRL")]
        ScancodeLctrl = 0xE0,
        [NativeName("Name", "SDL_SCANCODE_LSHIFT")]
        ScancodeLshift = 0xE1,
        [NativeName("Name", "SDL_SCANCODE_LALT")]
        ScancodeLalt = 0xE2,
        [NativeName("Name", "SDL_SCANCODE_LGUI")]
        ScancodeLgui = 0xE3,
        [NativeName("Name", "SDL_SCANCODE_RCTRL")]
        ScancodeRctrl = 0xE4,
        [NativeName("Name", "SDL_SCANCODE_RSHIFT")]
        ScancodeRshift = 0xE5,
        [NativeName("Name", "SDL_SCANCODE_RALT")]
        ScancodeRalt = 0xE6,
        [NativeName("Name", "SDL_SCANCODE_RGUI")]
        ScancodeRgui = 0xE7,
        [NativeName("Name", "SDL_SCANCODE_MODE")]
        ScancodeMode = 0x101,
        [NativeName("Name", "SDL_SCANCODE_AUDIONEXT")]
        ScancodeAudionext = 0x102,
        [NativeName("Name", "SDL_SCANCODE_AUDIOPREV")]
        ScancodeAudioprev = 0x103,
        [NativeName("Name", "SDL_SCANCODE_AUDIOSTOP")]
        ScancodeAudiostop = 0x104,
        [NativeName("Name", "SDL_SCANCODE_AUDIOPLAY")]
        ScancodeAudioplay = 0x105,
        [NativeName("Name", "SDL_SCANCODE_AUDIOMUTE")]
        ScancodeAudiomute = 0x106,
        [NativeName("Name", "SDL_SCANCODE_MEDIASELECT")]
        ScancodeMediaselect = 0x107,
        [NativeName("Name", "SDL_SCANCODE_WWW")]
        ScancodeWww = 0x108,
        [NativeName("Name", "SDL_SCANCODE_MAIL")]
        ScancodeMail = 0x109,
        [NativeName("Name", "SDL_SCANCODE_CALCULATOR")]
        ScancodeCalculator = 0x10A,
        [NativeName("Name", "SDL_SCANCODE_COMPUTER")]
        ScancodeComputer = 0x10B,
        [NativeName("Name", "SDL_SCANCODE_AC_SEARCH")]
        ScancodeACSearch = 0x10C,
        [NativeName("Name", "SDL_SCANCODE_AC_HOME")]
        ScancodeACHome = 0x10D,
        [NativeName("Name", "SDL_SCANCODE_AC_BACK")]
        ScancodeACBack = 0x10E,
        [NativeName("Name", "SDL_SCANCODE_AC_FORWARD")]
        ScancodeACForward = 0x10F,
        [NativeName("Name", "SDL_SCANCODE_AC_STOP")]
        ScancodeACStop = 0x110,
        [NativeName("Name", "SDL_SCANCODE_AC_REFRESH")]
        ScancodeACRefresh = 0x111,
        [NativeName("Name", "SDL_SCANCODE_AC_BOOKMARKS")]
        ScancodeACBookmarks = 0x112,
        [NativeName("Name", "SDL_SCANCODE_BRIGHTNESSDOWN")]
        ScancodeBrightnessdown = 0x113,
        [NativeName("Name", "SDL_SCANCODE_BRIGHTNESSUP")]
        ScancodeBrightnessup = 0x114,
        [NativeName("Name", "SDL_SCANCODE_DISPLAYSWITCH")]
        ScancodeDisplayswitch = 0x115,
        [NativeName("Name", "SDL_SCANCODE_KBDILLUMTOGGLE")]
        ScancodeKbdillumtoggle = 0x116,
        [NativeName("Name", "SDL_SCANCODE_KBDILLUMDOWN")]
        ScancodeKbdillumdown = 0x117,
        [NativeName("Name", "SDL_SCANCODE_KBDILLUMUP")]
        ScancodeKbdillumup = 0x118,
        [NativeName("Name", "SDL_SCANCODE_EJECT")]
        ScancodeEject = 0x119,
        [NativeName("Name", "SDL_SCANCODE_SLEEP")]
        ScancodeSleep = 0x11A,
        [NativeName("Name", "SDL_SCANCODE_APP1")]
        ScancodeApp1 = 0x11B,
        [NativeName("Name", "SDL_SCANCODE_APP2")]
        ScancodeApp2 = 0x11C,
        [NativeName("Name", "SDL_SCANCODE_AUDIOREWIND")]
        ScancodeAudiorewind = 0x11D,
        [NativeName("Name", "SDL_SCANCODE_AUDIOFASTFORWARD")]
        ScancodeAudiofastforward = 0x11E,
        [NativeName("Name", "SDL_NUM_SCANCODES")]
        NumScancodes = 0x200,
    }
}
